//+------------------------------------------------------------------+
//|                                                       SaxyEA.mq4 |
//|                                          SaxMan Copyright  2006 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "SaxMan Copyright  2007"
#property link      ""

//---- input parameters

extern string    Money_Management="+++++Money Management+++++";
extern double    Risk=2.0;

extern string    Trade_Parameters="+++++Trade Parameters+++++";
extern int       Slippage=3;
extern int       StopLoss=25;
extern int       TrailingStop=20;
extern int       TakeProfit=200;

extern string    Moving_Averages="+++++Moving Averages Parameters+++++";
extern int       FastMA=6;
extern int       FastMAMode=1;
extern int       FastMAPrice=0;
extern int       SlowMA=12;
extern int       SlowMAMode=1;
extern int       SlowMAPrice=1;

datetime timeprev=0;
datetime TimeCrossed;
         
         
int init()
{
 return(0);
}

int deinit()
{
 return(0);
}
 
int start()
{

//Trailing Stop
 TrailingAlls(TrailingStop);
 
//Close/Open
 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];
 

//Lots
double Lots=lotsize();

//Long
   
if(BuyCon1()==true)
 {
  CloseShorts();
  OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopLong(Ask,StopLoss),TakeLong(Ask,TakeProfit),NULL,0,0,Blue);
  Print ("going long");
 }
 
//Short
if(SellCon1()==true)
 {
  CloseLongs();
  OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,StopShort(Bid,StopLoss),TakeShort(Bid,TakeProfit),NULL,0,0,Red);
  Print ("going short");
 }
 return(0);
}
//-----Functions-----//

//--- lot size
double lotsize()
{
   double pipvalue=MarketInfo(Symbol(),MODE_TICKVALUE);
   double ls=((AccountFreeMargin()*(Risk/100))/StopLoss)/pipvalue;
   if(ls>100) ls=100;
   return(ls);
}

//-----Trade Rules------
//-----Buy Conditions-----
//-----BuyCon1 --- Moving Average Cross-----
bool BuyCon1()
{
   double FastMA1=iMA(NULL,0,FastMA,0,FastMAMode,FastMAPrice,1);
   double FastMA2=iMA(NULL,0,FastMA,0,FastMAMode,FastMAPrice,2);
   double SlowMA1=iMA(NULL,0,SlowMA,0,SlowMAMode,SlowMAPrice,1);
   double SlowMA2=iMA(NULL,0,SlowMA,0,SlowMAMode,SlowMAPrice,2);
   TimeCrossed=iTime(NULL,0,0);
   
   if(FastMA1>SlowMA1&&FastMA2<SlowMA2)
     {
     Comment("Crossed up at "+TimeCrossed);
     Print("Crossed up at "+TimeCrossed);
     return(true);
     }
   else
      return(false);
}

//-----Sell Conditions-----
//-----SellCon1 --- Moving Average Cross----
bool SellCon1()
{
   double FastMA1=iMA(NULL,0,FastMA,0,FastMAMode,FastMAPrice,1);
   double FastMA2=iMA(NULL,0,FastMA,0,FastMAMode,FastMAPrice,2);
   double SlowMA1=iMA(NULL,0,SlowMA,0,SlowMAMode,SlowMAPrice,1);
   double SlowMA2=iMA(NULL,0,SlowMA,0,SlowMAMode,SlowMAPrice,2);
   
   if(FastMA1<SlowMA1&&FastMA2>SlowMA2)
      {
      Comment("Crossed down at "+TimeCrossed);
      Print("Crossed down at "+TimeCrossed);
      return(true);
      }
   else
      return(false);

}
//-----Stop Functions----
double StopLong(double price,int stop)
{
 if(stop==0)
  return(0.0);
 return(price-(stop*Point));
}

double StopShort(double price,int stop)
{
 if(stop==0)
  return(0.0);
 return(price+(stop*Point));
}

double TakeLong(double price,int stop)
{
 if(stop==0)
  return(0.0);
 return(price+(stop*Point));
}

double TakeShort(double price,int stop)
{
 if(stop==0)
  return(0.0);
 return(price-(stop*Point));
}

//----- Close

void CloseLongs()
{
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol())
   continue;
   
  if(OrderType()==OP_BUY)
   OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue); 
 }
}  
  
void CloseShorts()
{
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol())
   continue;
   
  if(OrderType()==OP_SELL)
   OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red); 
 }
}

//-----TrailingStop
void TrailingAlls(int trail)
{
 if(trail==0)
  return;
  
double stopcurrent;
double stopcal;  
  
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol())
   continue;

//---Long   
  if(OrderType()==OP_BUY)
   {
    stopcurrent=OrderStopLoss();
    stopcal=Bid-(trail*Point);
    if(stopcurrent==0)
    {
     OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
    }
    else
    {
     if(stopcal>stopcurrent)
     {
     OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
     }
    }
   }
   
//---Short   
  if(OrderType()==OP_SELL)
   {
   stopcurrent=OrderStopLoss();
    stopcal=Ask+(trail*Point);
    if(stopcurrent==0)
    {
     OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
    }
    else
    {
     if(stopcal<stopcurrent)
     {
     OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
     }
    }
   }
 }
}

